//
// Cardiff University | Computer Science
// Module:     CM3203 One Semester Project (40 Credits)
// Title:      Parallelisation of Matrix Exponentials in C++/CUDA for Quantum Control
// Date:       2016
//
// Author:     Peter Davison
// Supervisor: Dr. Frank C Langbein
// Moderator:  Dr. Irena Spasic
//

#include "Main.h"
#include "cuda_profiler_api.h"

int main(int argc, char **argv) {

	try {

		cudaProfilerStart();

		int size = 5000;

		// Create variables
		//std::complex<double> i = std::complex<double>(0, 1);
		//CUDAMatrix A(size, {
		//	10, 2, 23, 13, 2,
		//	3, 5, 41, 18, 3,
		//	35, 12, 3, 13, 14,
		//	7, 22, 26, 2, 35,
		//	24, 31, 3, 66, 18
		//});
		CUDAMatrix A(size);
		A.setRandomDouble();
		CUDAMatrix eA(size);
		//CUDAMatrix eAi = CUDAMatrix(size);

		// Calculations
		CUDATimer t;
		t = CUDAMatrix::mul(A, A, eA);
		//CUDATimer t2 = CUDAMatrix::mul(eA, i, eAi);

		// Output
		//std::cout << "A" << A << std::endl;
		std::cout << t << std::endl;
		//std::cout << "e^A * i" << eAi << t2 << std::endl;

		cudaProfilerStop();
		
	} catch (std::exception e) {
		std::cout << std::endl << e.what() << std::endl;
	}

	return 0;

}